%  Copyright 2013 Kwang In Kim, Max-Planck-Institut for Informatics
%  Please refer to license.txt for sanctioned usage.
%
function [K] = ComputeCWGKernel(Nodes, Base, BaseIndexInG, rbf_var, LatDim)

[TCurva] = ConstructLocalTCoord(Nodes, Base, BaseIndexInG, LatDim);
TCurvOpr = 1+[abs(TCurva)]';

[NumTrnPtns,TrnNodesSize] = size(Nodes);
[NumBasePtns,BaseSize] = size(Base);
K = zeros(NumBasePtns,NumTrnPtns);
DistanceSq = zeros(1, NumTrnPtns);
InnerProduct = zeros(1, NumTrnPtns);
NodesNormSq = sum(Nodes.^2,2)';
BaseNormSq = sum(Base.^2,2)';
for i=1:NumBasePtns,
    PatternNormSq = BaseNormSq(i);
    InnerProduct = Base(i,:)*Nodes';
    DistanceSq = abs(PatternNormSq+NodesNormSq-2*InnerProduct);
    K(i,:) = exp(-DistanceSq/rbf_var);
    K(i,:) = K(i,:)./TCurvOpr;
end
