%  Copyright 2013 Kwang In Kim, Max-Planck-Institut for Informatics
%  Please refer to license.txt for sanctioned usage.
%
function [Feature] = ForwardPCA(Input, Forward, Mean, LatDim)

[~, ISize] = size(Forward);
[INum, InputSize] = size(Input);

if ISize ~= InputSize
    display('PCA model incompatible..');
    return;
end

Forward = Forward(1:LatDim,:);

CenteredInput = (Input-repmat(Mean,INum, 1));
Feature = CenteredInput*Forward';

% clear CenteredInput;
